SystemOrganization addCategory: #'Simon-Core'!
SystemOrganization addCategory: #'Simon-UI'!

Object subclass: #Simon
	instanceVariableNames: 'stack index step'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Simon-Core'!

!Simon commentStamp: 'BenjaminVanRyseghem 8/14/2010 18:37' prior: 0!
A Simon is a memory game :)

Instance Variables
	index:		an Integer 
	stack:		an OrderedCollection		

index
	- an Integer which represent the index of the next part

stack
	- a stack containing the sequence of the Simon
!

!Simon classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/15/2010 16:48'!
newGame

	self new newGame.! !

!Simon methodsFor: 'simon-behavior' stamp: 'BenjaminVanRyseghem 8/14/2010 18:42'!
addANewPart
	self push: self colors atRandom.! !

!Simon methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/14/2010 18:39'!
colors
	^#(#Blue #Red #Green #Yellow).! !

!Simon methodsFor: 'accesing' stamp: 'BenjaminVanRyseghem 8/14/2010 18:31'!
decrIndex
	index := index -1! !

!Simon methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/14/2010 19:34'!
delete
	self triggerEvent: #delete! !

!Simon methodsFor: 'simon-behavior' stamp: 'BenjaminVanRyseghem 8/15/2010 16:51'!
falseColor
	(self confirm: 'You loose !! Do you want to play another party ?')
		ifTrue: [self restart]
		ifFalse: [self delete].! !

!Simon methodsFor: 'simon-behavior' stamp: 'BenjaminVanRyseghem 8/15/2010 16:47'!
goodColor

	self index = self stack size
		ifTrue: [self newTurn]
		ifFalse: [self incrIndex.].! !

!Simon methodsFor: 'accesing' stamp: 'BenjaminVanRyseghem 8/14/2010 18:31'!
incrIndex
	index := index +1! !

!Simon methodsFor: 'accesing' stamp: 'BenjaminVanRyseghem 8/14/2010 18:33'!
index 
	^ index! !

!Simon methodsFor: 'simon-behavior' stamp: 'BenjaminVanRyseghem 8/15/2010 16:40'!
initIndex.
	index := 1.! !

!Simon methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/15/2010 16:41'!
initialize
	super initialize.

	index := 1.
	step := 1.
	stack := OrderedCollection new.! !

!Simon methodsFor: 'simon-behavior' stamp: 'BenjaminVanRyseghem 8/15/2010 16:12'!
isItTheGoodColor: aSymbol

	(self stack at: self index) = aSymbol
		ifTrue: [ self goodColor]
		ifFalse: [self falseColor].! !

!Simon methodsFor: 'new game' stamp: 'BenjaminVanRyseghem 8/15/2010 16:49'!
newGame
	self addANewPart.
	self openInWorld.
	self playSequence.! !

!Simon methodsFor: 'simon-behavior' stamp: 'BenjaminVanRyseghem 8/15/2010 16:43'!
newTurn
	self step timesRepeat:	[self addANewPart] .
	self initIndex.
	self playSequence.! !

!Simon methodsFor: 'stack-behavior' stamp: 'BenjaminVanRyseghem 8/14/2010 19:36'!
openInWorld
	SimonUI new 
		model: self;
		openInWorld.! !

!Simon methodsFor: 'stack-behavior' stamp: 'BenjaminVanRyseghem 8/14/2010 18:28'!
peek
	^ stack last! !

!Simon methodsFor: 'view managing' stamp: 'BenjaminVanRyseghem 8/14/2010 19:39'!
playSequence
	self triggerEvent: #sequence! !

!Simon methodsFor: 'stack-behavior' stamp: 'BenjaminVanRyseghem 8/14/2010 18:35'!
pop
	^stack removeLast
! !

!Simon methodsFor: 'stack-behavior' stamp: 'BenjaminVanRyseghem 8/14/2010 18:36'!
push: anObject

	stack addLast: anObject.! !

!Simon methodsFor: 'new game' stamp: 'BenjaminVanRyseghem 8/15/2010 16:52'!
restart
	self initialize.
	self addANewPart.
	self playSequence.! !

!Simon methodsFor: 'accesing' stamp: 'BenjaminVanRyseghem 8/14/2010 18:33'!
stack
	^ stack! !

!Simon methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/14/2010 19:37'!
step
	^step! !

!Simon methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/14/2010 19:37'!
step: anInteger
	step := anInteger! !

Object subclass: #SimonUI
	instanceVariableNames: 'squares model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Simon-UI'!

!SimonUI classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/14/2010 18:53'!
openInWorld
	self new openInWorld! !

!SimonUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/14/2010 19:45'!
blueSquare
	^self squares detect: [:each | each id = #Blue].! !

!SimonUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 8/14/2010 19:31'!
delete
	self greenSquare delete.
	self yellowSquare delete.
	self redSquare delete.
	self blueSquare delete.! !

!SimonUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/14/2010 19:45'!
greenSquare
	^self squares detect: [:each | each id = #Green].! !

!SimonUI methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/14/2010 19:48'!
initialize
	
	super initialize.
	
	squares := OrderedCollection new.
	
	self initializeBlueSquare.
	self initializeRedSquare.
	self initializeGreenSquare.
	self initializeYellowSquare.! !

!SimonUI methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/14/2010 19:46'!
initializeBlueSquare
	self squares add: (SimonSquare new 
					color: Color blue;
					model: self;
					id: #Blue;
					yourself).! !

!SimonUI methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/14/2010 19:47'!
initializeGreenSquare
	| greenSquare |
	greenSquare := SimonSquare new 
					color: Color green;
					model: self;
					id: #Green.
	greenSquare top: (greenSquare top + greenSquare size).
	self squares add: greenSquare.! !

!SimonUI methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/14/2010 19:47'!
initializeRedSquare
	| redSquare |
	redSquare := SimonSquare new 
					color: Color red;
					model: self;
					id: #Red.
	redSquare left: (redSquare left + redSquare size).
	self squares add: redSquare! !

!SimonUI methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 8/14/2010 19:47'!
initializeYellowSquare
	| yellowSquare |
	yellowSquare := SimonSquare new 
					color: Color yellow;
					model: self;
					id: #Yellow.
	yellowSquare top: (yellowSquare top + yellowSquare size).
	yellowSquare left: (yellowSquare left + yellowSquare size).
	self squares add: yellowSquare! !

!SimonUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/14/2010 19:32'!
model
	^model! !

!SimonUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/14/2010 19:39'!
model: aSimon
	model:= aSimon.
	aSimon
		when: #delete
		send: #delete
		to: self.
	aSimon
		when: #sequence
		send: #playSequence
		to: self.! !

!SimonUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 8/14/2010 18:49'!
openInWorld
	self blueSquare openInWorld.
	self redSquare openInWorld.
	self greenSquare openInWorld.
	self yellowSquare openInWorld.! !

!SimonUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 8/15/2010 16:06'!
playSequence
	| stack |
	stack := self model stack.
	1 to: stack size do: [:i |
			| square block process timeToSleep aDelay |
			block := [
				square := self squares detect: [:sq | sq id = (stack at: i)].
				
				timeToSleep := i*500.
				aDelay := Delay forMilliseconds: (timeToSleep).
				aDelay wait.
				square flash.].
			process := block newProcess.
			process resume]! !

!SimonUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/14/2010 19:46'!
redSquare
	^self squares detect: [:each | each id = #Red].! !

!SimonUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/15/2010 16:19'!
sendIdToModel: aSymbol
	self model isItTheGoodColor: aSymbol.! !

!SimonUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/14/2010 19:48'!
squares
	 ^squares! !

!SimonUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/14/2010 19:46'!
yellowSquare
	^self squares detect: [:each | each id = #Yellow].! !

Morph subclass: #SimonSquare
	instanceVariableNames: 'id model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Simon-UI'!

!SimonSquare methodsFor: 'display' stamp: 'BenjaminVanRyseghem 8/15/2010 15:56'!
flash
	| block process timeToSleep |
	timeToSleep := 100.
	block := [
		| aDelay oldColor |
		oldColor :=  self color.
		
		self color: Color white.
		"aDelay := Delay forMilliseconds: timeToSleep.
		aDelay wait."
		Semaphore new waitTimeoutMSecs: timeToSleep.
		self color: oldColor].
process := block newProcess.
process resume.
"(Delay forMilliseconds: timeToSleep) wait."! !

!SimonSquare methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/15/2010 16:39'!
handlerForMouseDown: anEvent 
	"Return the (prospective) handler for a mouse down event. The handler is temporarily 
	installed and can be used for morphs further down the hierarchy to negotiate whether 
	the inner or the outer morph should finally handle the event."

	anEvent blueButtonPressed
		ifTrue: [^ self handlerForBlueButtonDown: anEvent].
	anEvent yellowButtonPressed
		ifTrue: [^ self handlerForYellowButtonDown: anEvent.].
	anEvent redButtonPressed
		ifTrue: [self triggerEvent: #mouseDown].
	anEvent controlKeyPressed
		ifTrue: [^ self handlerForMetaMenu: anEvent].
	(self handlesMouseDown: anEvent)
		ifFalse: [^ nil].	"not interested"

	anEvent handler
		ifNil: [^ self ].	"Same priority but I am innermost"

	"Nobody else was interested"
	^self mouseDownPriority >= anEvent handler mouseDownPriority
		ifTrue: [ self]
		ifFalse: [ nil]! !

!SimonSquare methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/14/2010 19:27'!
id
	^id! !

!SimonSquare methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/14/2010 19:27'!
id: anIdentifiant
	id := anIdentifiant! !

!SimonSquare methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 8/14/2010 19:13'!
initialPosition
	^(200 @ 200)! !

!SimonSquare methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 8/14/2010 19:17'!
initialize
	super initialize.
	
	self width: self size.
	self height: self size.
	self beSticky.
	self topLeft: self initialPosition.! !

!SimonSquare methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/14/2010 19:30'!
model
	^model! !

!SimonSquare methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/15/2010 16:20'!
model: aSimonUI
	model := aSimonUI.
	self 
		when: #mouseDown
		send: #sendIdToModel
		to: self.! !

!SimonSquare methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 8/15/2010 16:40'!
sendIdToModel

	self model sendIdToModel: (self id).
	! !

!SimonSquare methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/14/2010 19:11'!
size
	^150! !
